library WebMail;

{ Diese Variante von Webmail ist bereits ab Delphi 3 (Standard) verwendbar. Dazu
  wurde das Projekt aus Delphi 5 "abwrts kompatibel" gemacht. Der Quelltext ist
  dabei nicht immer optimal!
}

uses Windows, Classes, SysUtils, Isapi, SimpleMail;

const sTitLog ='Login zum WebMail-Interface';       // diese Seitentitel knnten
      sTitBox ='WebMail-Mailbox';                // auch in der INI-Datei stehen
      sTitShow='Webmail-Nachricht';
      sTitSnd ='WebMail-Sendeergebnis';
      sTitAdm ='WebMail-Administration';
      sTitErr ='WebMail-Fehler';

type TUserData = Record                     // Datensatzabbild der Userdatenbank
  User: String; PassU: String; Name: String; eMail: String;
  Pop3: String; Smtp: String; Konto: String; Pass: String;
end;

var ScriptName, ScriptPathP, ScriptpathL, ScriptIni, DataBase: String;

{$R WMRes.res}                   // enthlt die Notfall-HTML-Vorlagen-Ressourcen

// ----- HTML-Hilfsroutinen ---------------------------------------------------

function HtmlLink(const sRef, sText: String): String;          {Link generieren}
var sTx: String;
begin
 if Length(sText)>0 then sTx:=sText else sTx:=sRef;
 HtmlLink:='<A href="'+sRef+'">'+sTx+'</A>';
end;

// ----- ECB-Hilfsfunktionen ---------------------------------------------------

function HxToInt(c: Char): Byte; var n: Byte;   {Dezimalwert eines Hex-Zeichens}
begin n:=Ord(UpCase(c))-48; if n>9 then Dec(n,7); HxToInt:=n; end;

function GetContentData(ECB: TEXTENSION_CONTROL_BLOCK; var List: TStringList): Boolean;
var pCont: PChar; nContentLength, i: Integer; sPair: String;
begin                                             {decodieren von Formulardaten}
 nContentLength:=ECB.cbAvailable;
 if nContentLength>=0 then begin
  pCont:=ECB.lpbData; sPair:=''; i:=0;
  while i<nContentLength do begin                          {Zeichen fr Zeichen}
   case (pCont+i)^ of                                  {Sonderzeichen behandeln}
    '+': sPair:=sPair+' ';
    '%': begin sPair:=sPair+Chr((HxToInt((pCont+i+1)^)shl 4)+HxToInt((pCont+i+2)^)); Inc(i,2) end;
    '&': begin List.Add(sPair); sPair:='' end;
    else sPair:=sPair+(pCont+i)^;                                {Normalzeichen}
   end;
   Inc(i,1);
  end;
  List.Add(sPair);
  GetContentData:=true;
 end else GetContentData:=false;
end;

function GetQueryData(ECB: TEXTENSION_CONTROL_BLOCK; var List: TStringList): Boolean;
var sQuery, sPair: String; nQueryLength, i: Integer;
begin                                             {decodieren von Formulardaten}
 if (ECB.lpszQueryString<>nil) then sQuery:=PChar(ECB.lpszQueryString) else sQuery:='';
 nQueryLength:=Length(sQuery);
 if nQueryLength>=0 then begin
  sPair:=''; i:=1;
  while i<=nQueryLength do begin                           {Zeichen fr Zeichen}
   case sQuery[i] of                                   {Sonderzeichen behandeln}
    '+': sPair:=sPair+' ';
    '%': begin sPair:=sPair+Chr((HxToInt(sQuery[i+1])shl 4)+HxToInt(sQuery[i+2])); Inc(i,2) end;
    '&': begin List.Add(sPair); sPair:='' end;
    else sPair:=sPair+sQuery[i];                                 {Normalzeichen}
   end;
   Inc(i);
  end;
  List.Add(sPair);
  GetQueryData:=true;
 end else GetQueryData:=false;
end;

function GetVar(ECB: TEXTENSION_CONTROL_BLOCK; ServerVar: PChar): String;
var cBuf: array[0..1535]of Char; BufLen: DWORD;
begin                                                {Server Variable ermitteln}
 BufLen:=SizeOf(cBuf); FillChar(cBuf,BufLen,#0);
 ECB.GetServerVariable(ECB.ConnID,ServerVar,Addr(cBuf),BufLen);
 GetVar:=cBuf;
end;

// ----- Hilfsfunktionen -------------------------------------------------------

function EnCrypt(const sIn: String): String;              //String verschlsseln
var s: String; i: Integer;
begin
 s:='';
 for i:=1 to Length(sIn) do s:=Format('%x',[Ord(sIn[i])-13])+s;
 EnCrypt:=s;
end;

function DeCrypt(const sIn: String): String;              //String entschlsseln
var s: String; i: Integer;
begin
 s:='';
 for i:=1 to Length(sIn) div 2 do
  s:=Chr((HxCharToInt(sIn[i+i-1])shl 4)+HxCharToInt(sIn[i+i])+13)+s;
 DeCrypt:=s;
end;

function GetUserData(var User: TUserData): Boolean;
// prft Usernamen und Passwort und fllt UserDat-Record mit allen Userdaten
// aus der Datenbank.
// Diese Routine bitte der eigenen Datenbank anpassen!!
var Data: TStringList; bOK: Boolean; nLn,nP: Integer; sLn, sUser: String;
begin
 bOK:=false; sUser:=LowerCase(User.User);
 if (Length(sUser)>0) and (Length(User.PassU)>0) then begin
  Data:=TStringList.Create;
  try Data.LoadFromFile(DataBase) except end;
  nLn:=0;
  while (not bOK) and (nLn<Data.Count) do begin
   sLn:=Data[nLn];              // eine Zeile als Semikolon-getrennter Datensatz
   nP:=Pos(';',sLn);
   if nP>0 then if sUser=Copy(sLn,1,nP-1) then begin            // User gefunden
    Delete(sLn,1,nP);                                          // um User krzen
    nP:=Pos(';',sLn);
    if nP>0 then if User.PassU=DeCrypt(Copy(sLn,1,nP-1)) then begin    // Pass OK
     Delete(sLn,1,nP);                                         // um Pass krzen
     nP:=Pos(';',sLn);
     if nP>0 then User.Name:=Copy(sLn,1,nP-1);                  // Name einlesen
     Delete(sLn,1,nP);                                        // um Namen krzen
     nP:=Pos(';',sLn);
     if nP>0 then User.eMail:=Copy(sLn,1,nP-1);        // eMail-Adresse einlesen
     Delete(sLn,1,nP);                                        // um eMail krzen
     nP:=Pos(';',sLn);
     if nP>0 then User.Pop3:=Copy(sLn,1,nP-1);            // Pop-Server einlesen
     Delete(sLn,1,nP);                                          // um Pop krzen
     nP:=Pos(';',sLn);
     if nP>0 then User.Smtp:=Copy(sLn,1,nP-1);           // Smtp-Server einlesen
     Delete(sLn,1,nP);                                          // um Pop krzen
     nP:=Pos(';',sLn);
     if nP>0 then User.Konto:=Copy(sLn,1,nP-1);            // Kontoname einlesen
     Delete(sLn,1,nP);                                        // um Konto krzen
     nP:=Pos(';',sLn);
     if nP>0 then Delete(sLn,nP,999);                        // Rest abschneiden
     if Length(sLn)>0 then begin User.Pass:=DeCrypt(sLn); bOK:=true; end;
    end; // if Pass
   end; // if sUser
   Inc(nLn);
  end; //while
  Data.Free;
 end; // if Length>0
 GetUserData:=bOK;
end;

function UpdateDataBase(UserDat: TUserData): Boolean;         // DatenbankUpdate
var Data: TStringList; bOK, bFound: Boolean; nLn,nP: Integer; sLn, sUser: String;
begin
 bOK:=false; sUser:=LowerCase(UserDat.User);
 if (Length(sUser)>0) and (Length(UserDat.PassU)>0) then begin
  Data:=TStringList.Create;
  try Data.LoadFromFile(DataBase) except end;
  nLn:=0; bFound:=false;
  while (not bFound) and (nLn<Data.Count) do begin
   sLn:=Data.Strings[nLn];
   nP:=Pos(';',sLn);
   if nP>0 then if sUser=Copy(sLn,1,nP-1) then begin            // User gefunden
    Delete(sLn,1,nP);                                          // um User krzen
    nP:=Pos(';',sLn);
    if nP>0 then if UserDat.PassU=DeCrypt(Copy(sLn,1,nP-1)) then begin // Pass OK
     Data.Delete(nLn); bFound:=true;        // alte Datensatz-Datenzeile lschen
    end;
   end;
   Inc(nLn)
  end;
  with UserDat do
  if (Length(Name)>0) and (Length(eMail)>0) and (Length(Pop3)>0)
                and (Length(Smtp)>0) and (Length(Konto)>0) and (Length(Pass)>0)
  then begin                  // neue Datensatz-Datenzeile erzeugen und anhngen
   Data.Add(Format('%s;%s;%s;%s;%s;%s;%s;%s;',
            [sUser,EnCrypt(PassU),Name,eMail,Pop3,Smtp,Konto,EnCrypt(Pass)]));
   try Data.SaveToFile(DataBase); bOK:=true; except end;
  end;
  Data.Free;
 end;
 UpdateDataBase:=bOK;
end;

// ----- Aktions-Funktionen ---------------------------------------------------

function ProduceLogin(const sPath, sAttempt: String): String;
var Templ: TMemoryStream; t, sNewScript: String; nP: Integer;
begin
 Templ:=TMemoryStream.Create;
 try
  Templ.LoadFromFile(ScriptPathP+'login.htm');
  SetString(t,PChar(Templ.Memory),Templ.Size);
 except t:='login.htm nicht gefunden' end;
 Templ.Free;
 if (sPath)='/admin' then sNewScript:=ScriptName+'/admin'
 else sNewScript:=ScriptName+'/login';
 nP:=Pos('#SCRIPT>',t);
 while nP>0 do begin
  Dec(nP); Delete(t,nP, 9); Insert(sNewScript,t,nP); nP:=Pos('#SCRIPT>',t)
 end;
 nP:=Pos('#ATTEMPT>',t);
 while nP>0 do begin
  Dec(nP); Delete(t,nP,10); Insert(sAttempt,t,nP); nP:=Pos('#ATTEMPT>',t)
 end;
 ProduceLogin:=t;
end;

function ProduceMailBox(Us: TUserData; const sLn, sCnt: String): String;
var Templ: TMemoryStream; t, sUsDat: String; nP: Integer;
begin
 Templ:=TMemoryStream.Create;
 try
  Templ.LoadFromFile(ScriptPathP+'mailbox.htm');
  SetString(t,PChar(Templ.Memory),Templ.Size);
 except t:='mailbox.htm nicht gefunden' end;
 Templ.Free;
 nP:=Pos('#SCRIPT>',t);
 while nP>0 do begin Dec(nP); Delete(t,nP, 9); Insert(ScriptName,t,nP); nP:=Pos('#SCRIPT>',t) end;
 nP:=Pos('#INMAILS>',t);
 while nP>0 do begin Dec(nP); Delete(t,nP,10); Insert(sCnt,t,nP); nP:=Pos('#INMAILS>',t) end;
 nP:=Pos('#SENDER>',t);
 while nP>0 do begin Dec(nP); Delete(t,nP, 9); Insert(Us.Name,t,nP); nP:=Pos('#SENDER>',t) end;
 nP:=Pos('#USERDATA>',t);
 while nP>0 do begin
  sUsDat:=Format(                                          // geheime Userdaten
  ' <INPUT TYPE="hidden" NAME="User"  VALUE="%s">'#13#10+
  ' <INPUT TYPE="hidden" NAME="PassU" VALUE="%s">'#13#10+
  ' <INPUT TYPE="hidden" NAME="Pop3"  VALUE="%s">'#13#10+
  ' <INPUT TYPE="hidden" NAME="Smtp"  VALUE="%s">'#13#10+
  ' <INPUT TYPE="hidden" NAME="Name"  VALUE="%s">'#13#10+
  ' <INPUT TYPE="hidden" NAME="eMail" VALUE="%s">'#13#10+
  ' <INPUT TYPE="hidden" NAME="Konto" VALUE="%s">'#13#10+
  ' <INPUT TYPE="hidden" NAME="Pass"  VALUE="%s">',
  [Us.User,Encrypt(Us.PassU),Us.Pop3,Us.Smtp,Us.Name,Us.eMail,Us.Konto,Encrypt(Us.Pass)]);
  Dec(nP); Delete(t,nP,11); Insert(sUsDat,t,nP); nP:=Pos('#USERDATA>',t)
 end;
 nP:=Pos('#LINES>',t); if nP>0 then begin Dec(nP); Delete(t,nP,8); Insert(sLn,t,nP) end;
 ProduceMailBox:=t;
end;

procedure ActionLogin(ECB: TEXTENSION_CONTROL_BLOCK; var PageTitle, HtmlDetail: String);
// Login (kalt) von auen oder (warm, mit MailBox-Zugang) vom Loginformular
var User: TUserData; Pop3: TPOP3Object; ContentFields: TStringList;
    sLnk, sVar, sPath: String;
    nMails, nErg, nI: Integer;
begin
 if (ECB.lpszPathInfo<>nil) then sPath:=PChar(ECB.lpszPathInfo) else sPath:='';
 if StrIComp(ECB.lpszMethod,'GET')=0 then begin                 // GET-Anmeldung
  HtmlDetail:=ProduceLogin(sPath,'0');
  PageTitle:=sTitLog;
 end else if StrIComp(ECB.lpszMethod,'POST')=0 then begin   // POST vom Formular
  ContentFields:=TStringList.Create; GetContentData(ECB,ContentFields);
  User.User:=ContentFields.Values['User'];
  User.PassU:=ContentFields.Values['Pass'];
  if sPath='/mailbox' then User.PassU:=DeCrypt(ContentFields.Values['PassU']);
  if GetUserData(User) then begin   // Userdatenbank abgecheckt und Daten geholt
   Pop3:=TPOP3Object.Create;
   Pop3.Server:=User.Pop3; Pop3.Konto:=User.Konto; Pop3.Pass:=User.Pass; nMails:=0;
   try
    nErg:=Pop3.CheckAccount;                      //Account am POPServer checken
    if nErg=POP3_MAILOK then begin         // Mailserver hat positiv geantwortet
     sVar:='';
     for nI:=0 to Pop3.Count-1 do begin         // ber alle vorhandenen e-Mails
      try nErg:=StrToInt(Pop3.GetSize(nI)) div 1024 +1 except nErg:=0 end;
      // Subject der e-Mail in Form eines Hyperlinks mit dem Pfad  /showmail mit
      // den Parametern  Username, Passwort, Nummer, POP-Server  fr die sptere
      // Anzeige der e-Mail generieren
      sLnk:=HtmlLink(Format('%s/showmail?s=%s&u=%s&p=%s&n=%d',[ScriptName,
       URLCode(Pop3.Server), URLCode(Pop3.Konto), EnCrypt(Pop3.Pass), nI+1]),
       Pop3.GetSubject(nI));
      // Zeile der Inbox-Tabelle mit Absender, Subjekt, Datum u. Gre erzeugen
      sVar:=sVar+Format(
       ' <TR><TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD></TR>'#13#10,
       [Format('<INPUT TYPE="checkbox" NAME="Del" VALUE="%d">',[nI+1]),
        HtmlMaskLtGt(Pop3.GetFrom(nI)), sLnk, Pop3.GetDate(nI),
        Format('%d KB',[nErg])]);
     end;
     nMails:=Pop3.Count;                                   // Anzahl der e-Mails
     if nMails>0 then  sVar:=sVar+                  // Button "Lschen" erzeugen
      ' <TR><TD COLSPAN="5"><INPUT TYPE="submit" VALUE="L&ouml;schen"></TD></TR>';
     HTMLDetail:=sVar;                               // Zeilen der Inbox-Tabelle
    end else begin                          // Mailserver hat Antwort verweigert
     case nErg of
      POP3_NOPASS  : sVar:='Passwort nicht korrekt';
      POP3_NOKONTO : sVar:='Konto nicht vorhanden';
      SOCK_NOSERVER: sVar:='Mailserver nicht bereit';
      SOCK_NONET   : sVar:='keine Netzwerkverbindung';
      POP3_NOPARAMS: sVar:='fehlende Userdaten';
     else sVar:='undefinierter Fehler' end;
     HTMLDetail:=Format('<TR><TD COLSPAN=5>'+
      '<H4>W&auml;hrend der &Uuml;bertragung ist ein Fehler aufgetreten!</H4>'+
      'Der Fehler lautet: <FONT COLOR="#CC0033">%s</FONT></TD></TR>',[sVar]);
    end;
   except {CheckAccount undefiniert} end;
   Pop3.Free;
   HTMLDetail:=ProduceMailbox(User,HtmlDetail,IntToStr(nMails)); // direkten Mailbox-Inhalt nach Muster erzeugen
   PageTitle:=sTitBox+' f&uuml;r '+User.eMail;
  end else begin       // Login falsch, zurck zum Login-Formular, neuer Versuch
   HTMLDetail:='<H3><FONT COLOR="#CC0033">Anmeldefehler!</FONT></H3>';
   try nI:=StrToInt(ContentFields.Values['Attempt'])+1 except nI:=0 end; // Hidden-Feld
   if nI<3 then begin       // erste/zweite Wiederholung: Fehlermeldung plus Wdh
    {HTMLDetail:=HTMLDetail+Format('Sie haben noch %d Versuche.',[3-nDetail]);}
    HTMLDetail:=HTMLDetail+ProduceLogin(sPath, IntToStr(nI));
    PageTitle:=sTitLog;
   end else begin                                 // mehr als drei Loginversuche
    HTMLDetail:=HTMLDetail+'Login gesperrt.';
    PageTitle:=sTitErr;
   end;
  end; // if GetUserData
  ContentFields.Free;
 end; // if POST
end;

function ProduceShowMail(const sHd, sTx, sAtt: String): String;
var Templ: TMemoryStream; t: String; nP: Integer;
begin
 Templ:=TMemoryStream.Create;
 try
  Templ.LoadFromFile(ScriptPathP+'showmail.htm');
  SetString(t,PChar(Templ.Memory),Templ.Size);
 except t:='showmail.htm nicht gefunden' end;
 Templ.Free;
 nP:=Pos('#ATTACHMENT>',t); if nP>0 then begin Dec(nP); Delete(t,nP,13); Insert(sAtt,t,nP) end;
 nP:=Pos('#HEADER>',t);     if nP>0 then begin Dec(nP); Delete(t,nP, 9); Insert(sHd,t,nP) end;
 nP:=Pos('#BODY>',t);       if nP>0 then begin Dec(nP); Delete(t,nP, 7); Insert(sTx,t,nP) end;
 ProduceShowMail:=t;
end;

procedure ActionShowMail(ECB: TEXTENSION_CONTROL_BLOCK; var PageTitle, HtmlDetail: String);
// eine e-Mail anzeigen
var Pop3: TPOP3Object; QueryFields: TStringList;
    HeadDetail, AddDetail: String;
    nErg, nNr, i: Integer; AttachNames: TStringList; SRec: TSearchRec;
begin
 QueryFields:=TStringList.Create; GetQueryData(ECB,QueryFields);
 Pop3:=TPOP3Object.Create;
 Pop3.Server:=QueryFields.Values['s'];             // Servername aus QueryString
 Pop3.Konto:=QueryFields.Values['u'];                // Username aus QueryString
 Pop3.Pass:=DeCrypt(QueryFields.Values['p']);           // PassW aus QueryString
 try nNr:=StrToInt(QueryFields.Values['n']) except nNr:=1 end;        // Mail-Nr
 QueryFields.Free;
 try
  nErg:=Pop3.RetrMail(nNr);                // holt die Mail Nr. i vom Mailserver
  if nErg=POP3_MAILOK then begin           // Mail i erfolgreich heruntergeladen
   // hier eventuell die gesamte Mail in einem Userverzeichnis abspeichern
   HeadDetail:=HtmlMaskLtGt(Pop3.GetHeader);            // "<" und ">" maskieren
   HtmlDetail:=Pop3.GetMailText;                        // eigentlicher MailText
   AddDetail:='';
   AttachNames:=TStringList.Create;
   AttachNames.Text:=Pop3.GetAttachNames;               // Namen der Attachments
   for i:=0 to AttachNames.Count-1 do begin             // ber alle Attachments
    if FindFirst(ScriptPathP+'inbox\*.*', faAnyFile, SRec)=0 then begin
     while FindNext(SRec)=0 do                  // alle alten Attachments prfen
      if (SRec.Attr and faDirectory)<>faDirectory then
       if FileDateToDateTime(SRec.Time)+0.1 < Now() then
        DeleteFile(ScriptPathP+'inbox\'+sRec.Name);   // lter als 2 Stunden weg
     FindClose(SRec);
    end else try MkDir(ScriptPathP+'inbox') except end;
    Pop3.StoreAttachment(i, ScriptPathP+'inbox\'+AttachNames[i]);
    AddDetail:=AddDetail+' '+HtmlLink(
                ScriptPathL+'/inbox/'+AttachNames[i],AttachNames[i])+#13#10;
   end;
   AttachNames.Free;
  end else begin                             // Mail i nicht erfolgreich geladen
   case nErg of
    POP3_NOPASS  : HTMLDetail:='Passwort nicht korrekt';
    POP3_NOKONTO : HTMLDetail:='Konto nicht vorhanden';
    SOCK_NOSERVER: HTMLDetail:='Mailserver nicht bereit';
    SOCK_NONET   : HTMLDetail:='keine Netzwerkverbindung';
    POP3_NOPARAMS: HTMLDetail:='fehlende Userdaten';
   else HTMLDetail:='undefinierter Fehler' end;
   HTMLDetail:=Format('<TR><TD COLSPAN=5>'+
    '<H4>W&auml;hrend der &Uuml;bertragung ist ein Fehler aufgetreten!</H4>'+
    'Der Fehler lautet: <FONT COLOR="#CC0033">%s</FONT></TD></TR>',[HTMLDetail]);
  end;
 except end;
 Pop3.Free;
 HTMLDetail:=ProduceShowMail(HeadDetail, HtmlDetail, AddDetail);
 PageTitle:=sTitShow+' '+IntToStr(nNr);
end;

procedure ActionDelete(ECB: TEXTENSION_CONTROL_BLOCK);
var Pop3: TPOP3Object; ContentFields: TStringList;
    i: Integer; sMails: String;
begin
 sMails:='';
 ContentFields:=TStringList.Create; GetContentData(ECB,ContentFields);
 for i:=0 to ContentFields.Count-1 do                // Checkboxen "Del=" suchen
  if UpperCase(Copy(ContentFields[i],1,4))='DEL=' then
   sMails:=sMails+Copy(ContentFields[i],5,9)+#13#10;
 if Length(sMails)>0 then begin
  Pop3:=TPOP3Object.Create;
  Pop3.Server:=ContentFields.Values['Pop3'];                      // Hidden-Feld
  Pop3.Konto:=ContentFields.Values['Konto'];                      // Hidden-Feld
  Pop3.Pass:=DeCrypt(ContentFields.Values['Pass']);               // Hidden-Feld
  try Pop3.DeleteMails(sMails) except end;
  Pop3.Free;
 end;
 ContentFields.Free
end;

function ProduceSendOK(Smtp: TSMTPObject): String;
var Templ: TMemoryStream; t, sTx: String; nP, nLn: Integer;
begin
 Templ:=TMemoryStream.Create;
 try
  Templ.LoadFromFile(ScriptPathP+'sendok.htm');
  SetString(t,PChar(Templ.Memory),Templ.Size);
 except t:='sendok.htm nicht gefunden' end;
 Templ.Free;
 nP:=Pos('#SENDER>',t);
 while nP>0 do begin Dec(nP); Delete(t,nP, 9); Insert(Smtp.Sender,t,nP); nP:=Pos('#SENDER>',t) end;
 nP:=Pos('#MAILTO>',t);
 while nP>0 do begin Dec(nP); Delete(t,nP, 9); Insert(Smtp.MailTo,t,nP); nP:=Pos('#MAILTO>',t) end;
 nP:=Pos('#SUBJECT>',t);
 while nP>0 do begin Dec(nP); Delete(t,nP,10); Insert(Smtp.Subject,t,nP); nP:=Pos('#SUBJECT>',t) end;
 nP:=Pos('#TEXT>',t); if nP>0 then begin
  nLn:=0; sTx:='';
  while nLn<Smtp.ContentLines do begin sTx:=sTx+Smtp.GetContentLine(nLn)+'<BR>'; Inc(nLn) end;
  Dec(nP); Delete(t,nP,7); Insert(sTx,t,nP)
 end;
 ProduceSendOk:=t;
end;

procedure ActionSend(ECB: TEXTENSION_CONTROL_BLOCK; var PageTitle, HtmlDetail: String);
var Smtp: TSmtpObject; ContentFields: TStringList;
    nErg: Integer;
begin
 Smtp:=TSmtpObject.Create;
 ContentFields:=TStringList.Create; GetContentData(ECB,ContentFields);
 Smtp.Server:=ContentFields.Values['Smtp'];                       // Hidden-Feld
 Smtp.MailTo:=ContentFields.Values['MailTo'];                    // Formularfeld
 Smtp.From:=ContentFields.Values['eMail'];                        // Hidden-Feld
 Smtp.Sender:=ContentFields.Values['Sender'];                    // Formularfeld
 Smtp.Subject:=ContentFields.Values['Subject'];                  // Formularfeld
 Smtp.SetContent(ContentFields.Values['Text']);                  // Formularfeld
 ContentFields.Free;
 nErg:=Smtp.SendMail;           //e-Mail senden mit Funktion aus Unit SimpleMail
 if nErg=SMTP_MAILOK then begin                         // Mail korrekt gesendet
  // eventuell e-Mail in einem User-Ordner "gesendet" auf dem Server speichern
  HTMLDetail:=ProduceSendOK(Smtp);
 end else begin             // Senden fehlerhaft, Fehlermeldungsseite generieren
  case nErg of
   SMTP_TRANSERR: HTMLDetail:='&Uuml;bertragungsfehler';
   SOCK_NOSERVER: HTMLDetail:='Mailserver nicht bereit';
   SOCK_NONET   : HTMLDetail:='keine Netzwerkverbindung';
   SMTP_NOPARAMS: HTMLDetail:='fehlende e-Mailangaben';
  else HTMLDetail:='undefinierter Fehler' end;
  HTMLDetail:=Format(
   '<H4>Bei der &Uuml;bermittlung der Daten ist ein Fehler aufgetreten!</H4>'+
   'Die Daten wurden <B>nicht</B> weitergeleitet.<BR>'+
   'Der Fehler lautet: <FONT COLOR="#CC0033">%s</FONT>'+
   '<P>[ <SMALL>%s</SMALL> ]</P>',
   [HtmlDetail,HtmlLink('javascript:history.back()','zur&uuml;ck zur Mailbox')]);
 end;
 Smtp.Free;                                                // nicht vergessen!!!
 PageTitle:=sTitSnd;
end;

function ProduceAdmin(Us: TUserData; const sQ: String): String;
var Templ: TMemoryStream; t, sDat: String; nP: Integer;
begin
 if sQ='data' then sDat:='adminok.htm' else sDat:='admin.htm';
 Templ:=TMemoryStream.Create;
 try
  Templ.LoadFromFile(ScriptPathP+sDat);
  SetString(t,PChar(Templ.Memory),Templ.Size);
 except t:=sDat+' nicht gefunden' end;
 Templ.Free;
 if sQ='' then sDat:=ScriptName+'/admin?data'  else sDat:=ScriptName;
 nP:=Pos('#SCRIPT>',t);  while nP>0 do begin Dec(nP); Delete(t,nP, 9); Insert(sDat,t,nP); nP:=Pos('#SCRIPT>',t) end;
 nP:=Pos('#USER>',t);  while nP>0 do begin Dec(nP); Delete(t,nP, 7); Insert(Us.User,t,nP); nP:=Pos('#USER>',t) end;
 nP:=Pos('#PASSU>',t); while nP>0 do begin Dec(nP); Delete(t,nP, 8); Insert(Us.PassU,t,nP); nP:=Pos('#PASSU>',t) end;
 nP:=Pos('#SENDER>',t);while nP>0 do begin Dec(nP); Delete(t,nP, 9); Insert(Us.Name,t,nP); nP:=Pos('#SENDER>',t) end;
 nP:=Pos('#EMAIL>',t); while nP>0 do begin Dec(nP); Delete(t,nP, 8); Insert(Us.eMail,t,nP);nP:=Pos('#EMAIL>',t) end;
 nP:=Pos('#POP3>',t);  while nP>0 do begin Dec(nP); Delete(t,nP, 7); Insert(Us.Pop3,t,nP); nP:=Pos('#POP3>',t) end;
 nP:=Pos('#SMTP>',t);  while nP>0 do begin Dec(nP); Delete(t,nP, 7); Insert(Us.Smtp,t,nP); nP:=Pos('#SMTP>',t) end;
 nP:=Pos('#PASS>',t);  while nP>0 do begin Dec(nP); Delete(t,nP, 7); Insert(Us.Pass,t,nP); nP:=Pos('#PASS>',t) end;
 nP:=Pos('#KONTO>',t); while nP>0 do begin Dec(nP); Delete(t,nP, 8); Insert(Us.Konto,t,nP);nP:=Pos('#KONTO>',t) end;
 ProduceAdmin:=t;
end;

procedure ActionAdmin(ECB: TEXTENSION_CONTROL_BLOCK; var PageTitle, HtmlDetail: String);
var User: TUserData; ContentFields: TStringList;
    sPath, sQuery: String;
begin
 if (ECB.lpszPathInfo<>nil) then sPath:=PChar(ECB.lpszPathInfo) else sPath:='';
 if StrIComp(ECB.lpszMethod,'GET')=0 then begin                 // GET-Anmeldung
  HtmlDetail:=ProduceLogin(sPath,'0');
  PageTitle:='Zugang zu '+sTitAdm;
 end else if StrIComp(ECB.lpszMethod,'POST')=0 then begin   // POST vom Formular
  ContentFields:=TStringList.Create; GetContentData(ECB,ContentFields);
  User.User:=ContentFields.Values['User'];
  User.PassU:=ContentFields.Values['Pass'];
  if (ECB.lpszQueryString<>nil) then sQuery:=PChar(ECB.lpszQueryString) else sQuery:='';
  if sQuery<>'data' then begin                   // Admin-Formular zum Ausfllen
   if GetUserData(User) then begin           // User vorhanden und Login korrekt
    HTMLDetail:='<P>Sie k&ouml;nnen nun Ihre bisherigen Zugangsdaten &auml;ndern:</P>';
   end else begin                                // unbekannter User, neuanlegen
    HTMLDetail:='<P>Tragen Sie hier Ihre Zugangsdaten f&uuml;r e-Mail ein:</P>';
    User.User:=''; User.PassU:=''; User.Name:=''; User.eMail:='';
    User.Pop3:=''; User.Smtp:=''; User.Konto:=''; User.Pass:='';
   end;
   HTMLDetail:=HTMLDetail+#13#10+ProduceAdmin(User,sQuery);
   PageTitle:=sTitAdm;
  end else begin      // Querystring war "data", Formular-Anmeldedaten speichern
   User.PassU:=ContentFields.Values['PassU'];
   User.Name:=ContentFields.Values['Sender']; User.eMail:=ContentFields.Values['eMail'];
   User.Pop3:=ContentFields.Values['Pop3'];   User.Smtp:=ContentFields.Values['Smtp'];
   User.Konto:=ContentFields.Values['Konto']; User.Pass:=ContentFields.Values['Pass'];
   if UpdateDataBase(User) then begin                 // erfolgreich gespeichert
    HTMLDetail:=ProduceAdmin(User,sQuery);
    PageTitle:=sTitAdm+' (Best&auml;tigung)';
   end else begin                                         // speichern miglckt
    HTMLDetail:='<P>Ihre Daten konnten <B>nicht</B> gespeichert werden.</P>';
    PageTitle:='Fehler '+sTitAdm;
   end;
  end;
  ContentFields.Free;
 end; // if GET/POST
end;

// ----- Initialisierungs-Hilfsfunktion ---------------------------------------

procedure SetVars;
var ScriptName: String; F: array[0..MAX_PATH-1] of Char;
begin
 SetString(ScriptName,F,GetModuleFilename(hInstance,F,SizeOf(F)));
 ScriptPathP:=ExtractFilePath(ScriptName);            // physischer Pfad der DLL
 DataBase   :=ScriptPathP+'DataBase.txt';     // Zugangsdatenbank (hier als TXT)
 ScriptIni  :=ChangeFileExt(ScriptName,'.ini');  // INI-Datei fr evt. Parameter
// {$I-} MkDir(ScriptPathP+'inbox'); {$I-} if IOResult=0 then;
end;

// ----- Export-Funktionen (Hauptprogramm) ------------------------------------

function HttpExtensionProc(var ECB: TEXTENSION_CONTROL_BLOCK): DWORD; stdcall;
var Templ: TMemoryStream; Res: TResourceStream;
    HtmlDetail, PageTitle, t, sPath: String;
    nP: Integer; StrLen: DWORD;
begin
 ECB.lpszLogData:='Delphi-DLL';
 PageTitle:=sTitErr; HTMLDetail:='illegaler Aufruf';               // vorbeugend
 ScriptName:=GetVar(ECB,'SCRIPT_NAME');
 nP:=Length(ScriptName)-1; while (nP>0) and (ScriptName[nP]<>'/') do Dec(nP);
 ScriptPathL:=Copy(ScriptName,1,nP-1);     // logischen Serverpfad heraustrennen
 if (ECB.lpszPathInfo<>nil) then sPath:=PChar(ECB.lpszPathInfo) else sPath:=''; if sPath='' then sPath:='/login';
 // Aktionen des WebMail-Interface dispatchen
 if sPath='/showmail'     then ActionShowMail(ECB, PageTitle, HtmlDetail)
 else if sPath='/login'   then ActionLogin(ECB, PageTitle, HtmlDetail)
 else if sPath='/mailbox' then begin ActionDelete(ECB); ActionLogin(ECB, PageTitle, HtmlDetail) end
 else if sPath='/send'    then ActionSend(ECB, PageTitle, HtmlDetail)
 else if sPath='/admin'   then ActionAdmin(ECB, PageTitle, HtmlDetail);
 // Template (Ausgabeschablone) laden
 Templ:=TMemoryStream.Create();
 try
  Templ.LoadFromFile(ScriptPathP+'webmail.htm');  // Master-Design der Antworten
 except                // falls nicht zu finden: Notreserven aus Ressource holen
  Res:=TResourceStream.Create(HInstance,'MainTemplate',RT_RCDATA);
  Templ.LoadFromStream(Res);
  Res.Free;
  Res:=TResourceStream.Create(HInstance,'LetterGif',RT_RCDATA);
  try Res.SaveToFile(ScriptPathP+'MAILICON.GIF') except end;
  Res.Free;
 end;
 SetString(t,PChar(Templ.Memory),Templ.Size);
 Templ.Free;
 // Platzhalter-Tags der Ausgabeschablone substituieren
 nP:=Pos('#SCRIPTDIR>',t); while nP>0 do begin Dec(nP); Delete(t,nP,12); Insert(ScriptPathL,t,nP); nP:=Pos('#SCRIPTDIR>',t) end;
 nP:=Pos('#TITLE>',t);  while nP>0 do begin Dec(nP); Delete(t,nP,8); Insert(PageTitle,t,nP); nP:=Pos('#TITLE>',t) end;
 nP:=Pos('#DATE>',t);   while nP>0 do begin Dec(nP); Delete(t,nP,7); Insert(FormatDateTime('dddd, yy-mm-dd',Now()),t,nP); nP:=Pos('#DATE>',t) end;
 nP:=Pos('#TIME>',t);   while nP>0 do begin Dec(nP); Delete(t,nP,7); Insert(FormatDateTime('hh:nn:ss',Now()),t,nP); nP:=Pos('#TIME>',t) end;
 nP:=Pos('#CONTENT>',t); if nP>0 then begin Dec(nP); Delete(t,nP,10); Insert(HtmlDetail,t,nP) end;
 // endgltige HTTP-Ausgabe zusammenstellen
 t:=Format('HTTP/1.0 200 OK'#13#10'Content-Type: text/html'#13#10'Content-Length: %d'#13#10'Content:'#13#10#13#10'%s',[Length(t),t]);
 StrLen:=Length(t);
 ECB.dwHTTPStatusCode:=200;
 ECB.WriteClient(ECB.ConnID,Pointer(t),StrLen,0);
 HttpExtensionProc:=HSE_STATUS_SUCCESS;
end;

function GetExtensionVersion(var Ver: THSE_VERSION_INFO): BOOL; stdcall;
begin
 Ver.dwExtensionVersion:=MAKELONG(HSE_VERSION_MINOR, HSE_VERSION_MAJOR);
 Ver.lpszExtensionDesc:='ISAPI-WebMail';
 GetExtensionVersion:=true;
end;

Exports GetExtensionVersion, HttpExtensionProc;

begin IsMultiThread:=true; SetVars; end.

